[![forthebadge](http://forthebadge.com/images/badges/built-with-love.svg)](https://www.gobolinux.org/)
[![forthebadge](http://forthebadge.com/images/badges/made-with-ruby.svg)](https://www.ruby-lang.org/en/)
[![Gem Version](https://badge.fury.io/rb/extracter.svg)](https://badge.fury.io/rb/extracter)
	
# Extracter

## Scope of Extracter

The scope (and goals) for **class Extracter** are really simple: throw any archive
format at it, and the class will try to **extract** it.

It can be used on the commandline as well.

## How to find out whether a given file is a valid archive

You can find out whether given input xyz is a valid archive by issuing
the following toplevel-method:

    Extracter.is_this_a_valid_archive?(path)

This will return either true or false.

## How to extract an archive through class Extracter, in pure ruby

You can use the following method to extract an archive, into a specific
target location:

    Extracter.extract_what_to('foo-1.0.tar.xz', '/tmp')

The first argument is the local path to an archive. The second
argument specifies the **target**, usually the target directory.

## Colour support

If the **Colours** gem (**gem install colours**) is available then colour
support is possible for **class Extracter**. For the class, the instance
variable **@use_colours** determines this. If you do not want to have
colours then you can disable this, e. g. through the method call
**.disable_colours** to give one example for doing so.

## class Extracter::ExtractIt

class Extracter::ExtractIt was a standalone .gem (named **extract_it**), 
but since as of September 2020 it is now part of "module Extracter".

Basically this class is is a wrapper over the class Extracter,
which will extract archives in general. The extraction step
will go into the current working directory.

## What archives and files can be extracted?

**class Extracter** can extract .tar.xz, .tar.bz, .tar.gz, tar.Z,
.zip and numerous other file formats. This requires that tools
such as **tar** or **gzip** or **xz** are installed and available
on the target computer-machine, as we will simply use ruby to
shell out to these other programs.

This class can also **extract audio-files** if ffmpeg is installed and
the multimedia_paradise project is available (**gem install
multimedia_paradise**), as well as squashfs files (typically 
.img files). In the latter case, such an .img file will be mounted 
in the current directory.

Support for extracting .jar files has been added in **May 2020**.

Support for 'extracting' .pdf files has been added in **January 2021**.
This depends on **poppler**, and it is not really an extraction; we
simply convert the file to a .txt (text) file. For this functionality
the **pdf_paradise** project has to be available.


## Contact information

If your creative mind has ideas and specific suggestions to make this
gem more useful in general, feel free to drop me an email at any
time, via:

    shevy@inbox.lt

Before that email I used an email account at Google gmail, but in **2021** I
decided to slowly abandon gmail for various reasons. In part this is because
the UI annoys me (on non-chrome browser loading takes too long), but also
because of Google's attempt to establish mass surveillance via its
federated cohorts sniffing (FLoC). I do not know what happened at Google,
but enough is enough - there is only so much you can take while supporting
greed. When it comes to data mining done by private groups, ultimately
the user became the product.

Do keep in mind that responding to emails may take some time,
depending on the amount of work I may have at that moment, due
to reallife time constraints. I will, however had, read feedback
eventually. Patches and code changes are welcome too, of course,
as long as they are in the spirit of the project at hand, e. g.
fitting to the general theme. For this I may make use of github
as a discussion site, but this has a low priority right now.

